WITH
  transfers AS (
    SELECT
      block_time AS time,
      amount AS amount,
      from_owner AS from_owner,
      to_owner AS to_owner,
      from_token_account AS from_token_account,
      to_token_account AS to_token_account,
      token_mint_address AS token_address,
      tx_id as transaction_id
    FROM
      tokens_solana.transfers
    WHERE
      block_date > (TIMESTAMP '2024-09-01 00:00:00 +08:00')
      AND token_address = '4GULMPKBJLruChBZWksZzukAg1AjSCmCTMn9ny2Xpump'
      AND action = 'transfer'
  )

WITH RECURSIVE inflow_owners AS (
  SELECT
    time,
    from_owner,
    to_owner,
    from_token_account,
    to_token_account,
    transaction_id,
    token_address,
    1 as level
  FROM
    transfers
  WHERE
    to_owner = 'ELeMLdqSaFF31SappKg4wrqBKmknguJrtAXRT8xbpWaP'

  UNION ALL

  SELECT
    t.time,
    t.from_owner,
    t.to_owner,
    t.from_token_account,
    t.to_token_account,
    t.transaction_id,
    t.token_address,
    io.level + 1 as level
  FROM
    transfers t
  INNER JOIN inflow_owners io ON t.from_owner = io.to_owner
  WHERE
    t.to_owner!= 'ELeMLdqSaFF31SappKg4wrqBKmknguJrtAXRT8xbpWaP'
),

-- SELECT
--     time，
--     from_owner,
--     to_owner,
--     from_token_account,
--     to_token_account,
--     transaction_id,
--     token_address
-- FROM
--   transfers
-- WHERE
  
--  (
--     to_owner = 'ELeMLdqSaFF31SappKg4wrqBKmknguJrtAXRT8xbpWaP'
--     OR from_owner = 'ELeMLdqSaFF31SappKg4wrqBKmknguJrtAXRT8xbpWaP'
--   )
-- ORDER BY
--   time ASC